local	AddonName, Version , ModulName = ... , GetAddOnMetadata ( ... , "Version" ) , "Currencies MOP"
local	Addon = CreateFrame ( "Frame" , nil , UIParent , BackdropTemplateMixin and "BackdropTemplate" ); Addon : SetAllPoints () ; 
	-------------------------------------------------------------------------------------------
        -- REGISTER EVENTS ------------------------------------------------------------------------
        -------------------------------------------------------------------------------------------
	Addon : RegisterEvent ( "ADDON_LOADED" );
	Addon : RegisterEvent ( "CURRENCY_DISPLAY_UPDATE" );
	-------------------------------------------------------------------------------------------
        -- Get Libraries  -------------------------------------------------------------------------
        -------------------------------------------------------------------------------------------
	local LibQTip		= LibStub : GetLibrary ( "LibQTip-1.0" );
	local LibDataBroker	= LibStub : GetLibrary ( "LibDataBroker-1.1" );
	-------------------------------------------------------------------------------------------
        -- ADDON VARIABLES ------------------------------------------------------------------------
        -------------------------------------------------------------------------------------------
	local WrapHex		= WrapTextInColorCode;
	local onText , offText	= WrapHex ( "On" , "ff" .. "009900" ) , WrapHex ( "Off" , "ff" .. "FF0000" );
	local RightButton	= " |T341461:20:16:0:-1:512:512:12:66:333:411|t ";
	local nocurrency	= "No Selected Currency";
	-------------------------------------------------------------------------------------------
        -- ADDON DEFAULT DATABASE -----------------------------------------------------------------
        -------------------------------------------------------------------------------------------
	local DefaultDB = {
	      { id =  777, category = 133, type = "currency", ldb = true,  name = "Timeless Coin",},
	      { id =  738, category = 133, type = "currency", ldb = false, name = "Lesser Charm of Good Fortune",},
	      { id =  697, category = 133, type = "currency", ldb = false, name = "Elder Charm of Good Fortune",},
	      { id =  752, category = 133, type = "currency", ldb = false, name = "Mogu Rune of Fate",},
	      { id =  776, category = 133, type = "currency", ldb = false, name = "Warforged Seal",},
	      { id =  789, category = 133, type = "currency", ldb = false, name = "Bloody Coin",},
	}
	local Text = ""
	-------------------------------------------------------------------------------------------
        -- DataBroker FUNCTIONS ------------------------------------------------------------------------
        -------------------------------------------------------------------------------------------
	 local LDB	 = LibDataBroker : GetDataObjectByName ( "(D) " .. ModulName ) or LibDataBroker : NewDataObject ( "(D) " .. ModulName , { type = "data source" } )
	       LDB.title = "|cffFF0000 (D) |r" ..  "|cff0080FF" .. ModulName .. "|r " ..  "|cffFFFFFF" .. Version .. "|r ";
	       LDB.label = "(D) " .. ModulName;

function LDB.OnEnter ( self )
	 if (not inCombat or inCombat == "block") and InCombatLockdown() then return end
		 LibQTip : Release ( self.QTip ); self.QTip = nil;
		 QTip = LibQTip : Acquire ( ModulName .. "Tooltip" , 4 , "LEFT" , "RIGHT" , "RIGHT" ); self.QTip = QTip;

		 QTip : SetFrameStrata ( "FULLSCREEN" )
		 QTip : SmartAnchorTo ( self )
		 QTip : EnableMouse ( true )
		 QTip : SetAutoHideDelay ( 0.1 , self )
	 -------------------------------------------------------------------------------------------
	 -- Tooltip Header -------------------------------------------------------------------------
	 -------------------------------------------------------------------------------------------
	      -- Setup Header Font Size
		 QTip : SetFont ( GameTooltipHeaderText )
		 QTip : AddSeparator ( 1 , 1 , 1 , 1 , 0 )
	      -- Add Line
		 row , column = QTip : AddLine ( "" )
		 QTip : SetCell ( row , 1 , GetAddOnMetadata ( AddonName , "Title" ) , "LEFT", 1)
		 QTip : SetColumnTextColor ( 1 , 1 , 0 , 0 , 1 )
		 QTip : SetCell ( row , 3 , "|cffFFFFFF" .. Version .. "|r" , "RIGHT", 1)
		 QTip : AddSeparator ( 2 , 1 , 1 , 1 , 0 )
	      -- Add Separator	Line ( thickness , r , g , b , alpha)
		 row , column = QTip : AddSeparator ( 1 )
		 QTip.lines[row]:SetBackdrop({bgFile = "Interface/Buttons/WHITE8X8", tile = true })
		 QTip.lines[row]:SetBackdropColor ( 1 , 0.8 , 0 , 1)
	      -- Setup Tooltip Font Size				 
		 QTip : SetFont ( GameTooltipText )
	 -------------------------------------------------------------------------------------------
	 -- Currencies -------------------------------------------------------------------------
	 -------------------------------------------------------------------------------------------
		 QTip : AddSeparator ( 1 , 1 , 1 , 1 , 0 )
		 
		 for k , v in pairs( CurrenciesMOP ) do
			local TooltipInfo = C_CurrencyInfo.GetCurrencyInfo ( CurrenciesMOP[k].id )
			if TooltipInfo.discovered then 
				row , column = QTip : AddLine ( "" )
				QTip : SetLineTextColor ( row , 1 , 1 , 1 , 1 )
				QTip : SetCell ( row , 1 , "|T" .. TooltipInfo.iconFileID .. ":20:20|t " .. TooltipInfo.name , "LEFT" , 1)

				if TooltipInfo.maxQuantity >0 
				   then QTip : SetCell ( row , 2 , TooltipInfo.quantity .. "/" .. TooltipInfo.maxQuantity , "RIGHT" , 1)
				   else QTip : SetCell ( row , 2 , TooltipInfo.quantity , "RIGHT" , 1)
				end
				
				QTip : SetCell ( row , 3 , CurrenciesMOP[k].ldb  and onText or offText , "RIGHT" , 1)
				QTip : SetLineScript( row , 'OnMouseDown' , function (self, button) 
				       CurrenciesMOP[k].ldb = not CurrenciesMOP[k].ldb;
				       self.cells[3].fontString : SetText ( CurrenciesMOP[k].ldb  and onText or offText , "RIGHT" )
				       Addon : DataObjectUpdate ( CurrenciesMOP )
				end)

				QTip : SetLineScript( row , 'OnMouseUp' , function (self, button) 
				       LibQTip : Release ( self.QTip ); self.QTip = nil;
				end)
			end
		 end

		 QTip : AddSeparator ( 1 , 1 , 1 , 1 , 0 )
	 -------------------------------------------------------------------------------------------
	 -- Features
	 -------------------------------------------------------------------------------------------
		  row , column = QTip : AddSeparator ( 1 )
		  QTip.lines[row]:SetBackdrop({bgFile = "Interface/Buttons/WHITE8X8", tile = true })
		  QTip.lines[row]:SetBackdropColor ( 1 , 0.8 , 0 , 1)

		  QTip : AddSeparator ( 5 , 1 , 1 , 1 , 0 )

		  row , column = QTip : AddLine ( "" )
		  QTip : SetCell ( row , 1 , "Click on the Currency to Toggle " .. onText .. "/" .. offText , "CENTER" , 3)

		  QTip : AddSeparator ( 5 , 1 , 1 , 1 , 0 )
		  
		  row , column = QTip : AddLine ( "" )
		  QTip : SetCell ( row , 1 , RightButton .. "Click + CTRL + SHIFT Reset to Default" , "CENTER" , 3)
		  
		  row , column = QTip : AddLine ( "" )
		  QTip : SetCell ( row , 1 , WrapHex ( "The user interface will reload!" , "ff" .. "FF0000" ) , "CENTER" , 3)

		  QTip : AddSeparator ( 5 , 1 , 1 , 1 , 0 )
	 -------------------------------------------------------------------------------------------
	 -- Copyright
	 -------------------------------------------------------------------------------------------
	       -- Add Separator	Line ( thickness , r , g , b , alpha)			 
		  row , column = QTip : AddSeparator ( 1 )
		  QTip.lines[row]:SetBackdrop({bgFile = "Interface/Buttons/WHITE8X8", tile = true })
		  QTip.lines[row]:SetBackdropColor ( 0.8 , 0 , 0 , 1) -- RED

		  row , column = QTip : AddLine ( "" )
		  QTip : SetCell ( row , 1 , WrapHex ( "Coded by " , "ff" .. "3399FF" ) .. WrapHex ( "Devil " , "ff" .. "FF0000" ).. WrapHex ( "(C)" , "ff" .. "FFFFFF" ) , "RIGHT" , 3)
	 -------------------------------------------------------------------------------------------
	 -- Show Tooltip
	 -------------------------------------------------------------------------------------------
		  QTip : Show ( )
	 end

	 function LDB.OnClick ( self, button , ...) 
		if ( button == "RightButton" and IsShiftKeyDown() and IsControlKeyDown() ) then
			CurrenciesMOP = DefaultDB
		end
		ReloadUI ();
	 end
	 -------------------------------------------------------------------------------------------
         -- ADDON FUNCTIONS ------------------------------------------------------------------------
         -------------------------------------------------------------------------------------------
function Addon : DataObjectUpdate ( database )
		 Text = ""
		 for k , v in pairs ( database ) do
		     local info = C_CurrencyInfo.GetCurrencyInfo ( database[k].id )
		     local icon = "|T" .. info.iconFileID .. ":20:20|t"
		     if database[k].ldb and info.discovered and info.quantity > 0 then Text = Text .. icon .. " " ..info.quantity .. " " end
		 end

		LDB.text = (Text ~= "") and Text or nocurrency;
end
	 -------------------------------------------------------------------------------------------
         -- EVENT FUNCTIONS ------------------------------------------------------------------------
         -------------------------------------------------------------------------------------------
	 Addon : SetScript ( "OnEvent", function ( self , event, ... ) 

		 if event == "ADDON_LOADED" then 
	
			-- ADDON DATABASE CHECK ----------------------------------------------------------	
			if ( not CurrenciesMOP ) then CurrenciesMOP = {} end;			
			-- COPY DEFAULT DATABASE ---------------------------------------------------------
			for k in pairs( DefaultDB ) do if (CurrenciesMOP[k]) == nil  then CurrenciesMOP[k] = DefaultDB[k]; end end
				 
			Addon : DataObjectUpdate ( CurrenciesMOP );
			-- ADDON LOADED MESSAGE ----------------------------------------------------------
			print ( "|cffFF0000(D) |r" .. ModulName .. " |cff0080FF" .. Version .. "|r Loaded ... " );
			-- UNREGISTER EVENT
			Addon : UnregisterEvent ( "ADDON_LOADED" );
		else
			Addon : DataObjectUpdate ( CurrenciesMOP );
		end
	end)